
package net.mcreator.outerspaceexplorers.world.biome;

import net.minecraftforge.registries.ObjectHolder;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.gen.surfacebuilders.SurfaceBuilderConfig;
import net.minecraft.world.gen.surfacebuilders.SurfaceBuilder;
import net.minecraft.world.biome.DefaultBiomeFeatures;
import net.minecraft.world.biome.Biome;
import net.minecraft.entity.EntityClassification;

import net.mcreator.outerspaceexplorers.entity.VoidSpiderEntity;
import net.mcreator.outerspaceexplorers.entity.SpaceGhastEntity;
import net.mcreator.outerspaceexplorers.block.MoonStoneBlock;
import net.mcreator.outerspaceexplorers.OuterSpaceExplorersModElements;

@OuterSpaceExplorersModElements.ModElement.Tag
public class OuterSpaceIslandBiome extends OuterSpaceExplorersModElements.ModElement {
	@ObjectHolder("outer_space_explorers:outer_space_island")
	public static final CustomBiome biome = null;
	public OuterSpaceIslandBiome(OuterSpaceExplorersModElements instance) {
		super(instance, 3);
	}

	@Override
	public void initElements() {
		elements.biomes.add(() -> new CustomBiome());
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
	}
	static class CustomBiome extends Biome {
		public CustomBiome() {
			super(new Biome.Builder().downfall(0f).depth(0.5f).scale(0.2f).temperature(1.6f).precipitation(Biome.RainType.NONE)
					.category(Biome.Category.NONE).waterColor(-16777216).waterFogColor(-16777216)
					.surfaceBuilder(SurfaceBuilder.DEFAULT, new SurfaceBuilderConfig(MoonStoneBlock.block.getDefaultState(),
							MoonStoneBlock.block.getDefaultState(), MoonStoneBlock.block.getDefaultState())));
			setRegistryName("outer_space_island");
			DefaultBiomeFeatures.addCarvers(this);
			DefaultBiomeFeatures.addStructures(this);
			DefaultBiomeFeatures.addMonsterRooms(this);
			DefaultBiomeFeatures.addOres(this);
			this.addSpawn(EntityClassification.CREATURE, new Biome.SpawnListEntry(VoidSpiderEntity.entity, 15, 1, 5));
			this.addSpawn(EntityClassification.CREATURE, new Biome.SpawnListEntry(SpaceGhastEntity.entity, 15, 1, 5));
		}

		@OnlyIn(Dist.CLIENT)
		@Override
		public int getGrassColor(double posX, double posZ) {
			return -13261999;
		}

		@OnlyIn(Dist.CLIENT)
		@Override
		public int getFoliageColor() {
			return -13261999;
		}

		@OnlyIn(Dist.CLIENT)
		@Override
		public int getSkyColor() {
			return -16777216;
		}
	}
}
